
(function () {
	var yuigen = 0,
		_caches = {};
	zk.afterMount(function () {
		if (!window.YAHOO)
			window.YAHOO = {};
		if (!YAHOO.widget)
			YAHOO.widget = {};
		if (!YAHOO.widget.FlashAdapter)
			YAHOO.widget.FlashAdapter = {};

		var oldHandler = YAHOO.widget.FlashAdapter.eventHandler;
		YAHOO.widget.FlashAdapter.eventHandler = function (id, event) {
			if (id && event.type == "swfReady") {
				for (var nm in _caches) {
					if (_caches[nm] == id) {
						var wgt = zk.Widget.$(nm);
						if (wgt) {
							zul.fchart2.Flashchart.onEvent(nm, event);
							break;
						}
					}
				}
			} else if (oldHandler)
				oldHandler.apply(this, arguments);
		}
		
	});
	var _src = zk.ajaxURI('/web/js/zul/fchart2/charts.swf', {au: true}),
		_expressInstall = zk.ajaxURI('/web/js/zul/fchart2/expressinstall.swf', {au: true}),
		_axis = {
			stackingEnabled: true,
			type: "numeric",
			alwaysShowZero: true,
			hideOverlappinLabels: true,
			reverse: false,
			scale: "linear",
			snapToUnits: true
		};
		
	function JSONEncode(x) {
		switch (typeof x) {
			case "number":
				return String(x);
			case "boolean":
				return String(x);
			case "string":
				return '"' + x + '"';
			default:
				return "null";
		}
	}
	
	
	function formatToJSON(str) {
		var list = str.split(','), 
			len = list.length, 
			categorys = [], 
			result = ['{'], 
			cl;
		
		for (var j = 0; j < len; j++) {
			var temp = list[j].split('-'),
				category = !temp[2] ? temp[0] : temp[1],
				alreadyHaveCategory = false,
				attr, val;
			if (!temp[1]) {
				result.push("}");
				break;
			}
			if (!temp[2]) {
				attr = temp[1].split('=')[0],
				val = temp[1].split('=')[1];
			} else {
				attr = temp[2].split('=')[0],
				val = temp[2].split('=')[1];
			}			
			cl = categorys.length;
			if (cl > 0) {
				for (var i = 0; i < cl; i++) {
					if (categorys[i].match(category)) {
						alreadyHaveCategory = true;
						break;
					}
				}
			}
			if (!alreadyHaveCategory) {
				categorys.push(JSONEncode(category));					
				if (!temp[2]) {
					result.push(JSONEncode(category), ":");
				} else {
					result.push(",", JSONEncode(category), ":");
				}
				result.push("{", JSONEncode(attr), ":", JSONEncode(val));
			} else {
				result.push(",", JSONEncode(attr), ":", JSONEncode(val));
			} 
		}
		cl = categorys.length;
		for (var j = 0; j < cl; j++) {
			result.push('}');
		}
		result.push('}');
		return result.join("");		
	}
	
	
	function onFlashEvent(wgt, event) {
		var swf = wgt.$n('chart'),
			type = wgt._type,
			chartStyle = wgt._chartStyle,
			data = jq.evalJSON(wgt._jsonModel),
			series = (type == 'pie') ? false : jq.evalJSON(wgt._jsonSeries),
			dataProvider = seriesProvider(series, type, data);
		
		swf.setType(type);
		swf.setStyles(formatToJSON(chartStyle || wgt._defaultStyle));
		
		if (type == "pie") {
			swf.setCategoryField("categoryField");
			swf.setDataField("dataField");
			
		} else if (type == "bar" || type == "stackbar") {
			swf.setHorizontalAxis(_axis);
			swf.setVerticalField("values");
			
		} else {
			swf.setVerticalAxis(_axis);
			swf.setHorizontalField("values");
			
		}
		swf.setDataProvider(dataProvider);
	}
	
	
	function refresh(wgt, dataModel) {
		var type = wgt._type,
			data = jq.evalJSON(dataModel),
			series = (type == 'pie') ? false : jq.evalJSON(wgt._jsonSeries),
			dataProvider = seriesProvider(series, type, data);
		wgt.$n('chart').setDataProvider(dataProvider);
	}
	
	function seriesProvider(series, type, data) {
		if (!series)
			return [{type: type, dataProvider: data}];
		
		var dataProvider = [];
		for (var i = 0, len = series.length; i < len; i++) {
			var current = series[i],
	  			clone = {};
	  		for (var key in current) {
	  			if (key == "style" && current.style !== null)
	  				clone.style = formatToJSON(current.style);
	  			else
	  				clone[key] = current[key];
	  		}
			if (!clone.type)
				clone.type = type;
			clone.dataProvider = data;
	  		dataProvider.push(clone);
	  	}
		return dataProvider;
	}

var Flashchart =

zul.fchart2.Flashchart = zk.$extends(zul.med.Flash, {

	
	_width: "400px",
	_height: "200px",
	_defaultStyle: "legend-display=right,legend-padding=10,legend-spacing=5,legend-font-family=Arial,legend-font-size=13",

	$define: {
		
		
		chartStyle: null,
		
		
		jsonModel: null,
		
		
		jsonSeries: null,
		
		
		type: null
	},
	setRefresh: function (mod) {
		refresh(this, mod);
	},
	bind_: function (desktop, skipper, after) {
		this.$supers(Flashchart, 'bind_', arguments);
		var _swfId = this.uuid + "-chart",
			_flashvars = "allowedDomain=" + (document.domain || 'localhost') + "&elementID=yuigen" + yuigen + 
				"&eventHandler=zul.fchart2.Flashchart.onEvent",
			_params = {				
				flashvars: _flashvars,
				allowScriptAccess: "always",
				bgcolor: "#ffffff",
				wmode: "opaque"
			},
			_attributes = {id: _swfId, classid: "clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"};
		
		var src = _src;
		if (zk.ie || zk.opera) 
			src += (src.indexOf('?') === -1 ? '?' : '&') + "_cache=" + new Date().getTime();
		zul.fchart2.swfobject.embedSWF(src, _swfId, this._width, this._height, 
				"9.0.0", _expressInstall, false, _params, _attributes);
		
		_caches[_swfId] = 'yuigen' + yuigen++;
	},
	unbind_: function () {
		delete _caches[this.uuid + '-chart'];
		this.$supers(Flashchart, 'unbind_', arguments);
	}
	
}, { 
	
	onEvent: function (id, event) {
		var eventType = event.type;
		if (eventType == "swfReady") {
			var comp = zk.Widget.$(id);
			if (comp)
				onFlashEvent(comp, event);
		}
	}
	
});
})();